#!/usr/bin/perl -w

use CGI qw/:standard *pre/;
# http://www.geocities.co.jp/SiliconValley-Sunnyvale/6128/perl/cgipm.html
# http://www.tohoho-web.com/wwwperl1.htm

sub ln { "\n"; }

my $referer = $ENV{'HTTP_REFERER'};
my $dim = int(param('dim'));

sub call_quadraticM {
    open(OUT, "|./odicon DQM $dim") || die('Can not call ./odicon');
    #open(OUT, '|cat') || die('Can not call ./odicon');

    for ($i=0; $i<$dim; $i++) {
	for ($j=0; $j<$dim; $j++) {
	    if ($i < $j) {
		print OUT int(param("a:$j")), ' ';
	    } else {
		print OUT int(param("a:$i")), ' ';
	    }
	}
	print OUT ln;
    }
    foreach $e ('b', 'x') {
	for ($j=0; $j<$dim; $j++) {
	    print OUT int(param("$e:$j")), ' ';
	}
	print OUT ln;
    }
    close OUT;
}

sub call_quadraticL {
    open(OUT, "|./odicon DQL $dim") || die('Can not call ./odicon');
    #open(OUT, '|cat') || die('Can not call ./odicon');

    for ($i=0; $i<$dim; $i++) {
	for ($j=0; $j<$dim; $j++) {
	    if ($i >= $j) {
		print OUT int(param("a:$i:$j")), ' ';
	    } else {
		print OUT int(param("a:$j:$i")), ' ';
	    }
	}
	print OUT ln;
    }
    foreach $e ('b', 'x') {
	for ($j=0; $j<$dim; $j++) {
	    print OUT int(param("$e:$j")), ' ';
	}
	print OUT ln;
    }
    close OUT;
}

sub call_shift {
    open(OUT, "|./odicon DS 3") || die('Can not call ./odicon');
    #open(OUT, '|cat') || die('Can not call ./odicon');
    print OUT param('criterion')/3600, ln;
    print OUT param('mu'), ln;
    foreach $e ('rate') {
	for ($j=0; $j<$dim; $j++) {
	    print OUT param("$e:$j"), ' ';
	}
	print OUT ln;
    }

    foreach $e ('y') {
	for ($j=0; $j<4; $j++) {
	    print OUT param("$e:$j"), ' ';
	}
	print OUT ln;
    }
    close OUT;
}

sub call_shift2 {
    open(OUT, "|./odicon DT 3") || die('Can not call ./odicon');
    #open(OUT, '|cat') || die('Can not call ./odicon');
    print OUT param('criterion')/3600, ln;
    print OUT param('mu'), ln;
    print OUT param('gr'), ln;
    foreach $e ('rate') {
	for ($j=0; $j<$dim; $j++) {
	    print OUT param("$e:$j"), ' ';
	}
	print OUT ln;
    }

    foreach $e ('y', 's') {
	for ($j=0; $j<4; $j++) {
	    print OUT param("$e:$j"), ' ';
	}
	print OUT ln;
    }
    close OUT;
}



print header(-expires=>'+1m'), # cache expires in 1min
    start_html(-title=>'result'), ln,
    start_pre, ln;

if ($referer =~ /\/demo-quadraticM.cgi$/) {
    call_quadraticM();
} elsif ($referer =~ /\/demo-quadraticL.cgi$/) {
    call_quadraticL();
} elsif ($referer =~ /\/demo-shift.cgi$/) {
    call_shift();
} elsif ($referer =~ /\/demo-shift2.cgi$/) {
    call_shift2();
} else {
    print "Unknown referer : $referer\n";
}

print end_pre, ln, end_html, ln;
