
double quadratic (const int dim, int *x, double **a);
double quadratic2(const int dim, int *x, double **a, double *b);
double quadratic3(const int dim, int *x, double **a, double *b, double c);

int is_lgconv_quadratic(const int dim, double **a);
int  is_lconv_quadratic(const int dim, double **a);
int is_mgconv_quadratic(const int dim, double **a);
int  is_mconv_quadratic(const int dim, double **a);

int make_hesse_lg(const int dim, double f(int,int*), int *x, double **a);
#define make_hesse_l make_hesse_lg
int make_hesse_mg(const int dim, double f(int,int*), int *x, double **a);
int make_hesse_m(const int dim, double f(int,int*), int *x, double **a);
int make_hesse_m2(const int dim, double f(int,int*), int *x, double **a);
int make_liner_const(const int dim, double f(int,int*), int *x,
                     double **a, double *b, double *c);
